package org.openstreetmap.josm.plugins.lanetool.data;

import org.openstreetmap.josm.data.osm.OsmPrimitive;

/**
 * tag-independent representation of a lane direction.
 * Can get and set a lane's direction using the lane's tags.
 */
public enum Direction {
	FORWARD, BACKWARD, BOTH;

	static Direction getDirection(OsmPrimitive primitive) {
		
		String valueString = primitive.get("oneway");

		if ("yes".equals(valueString) || "true".equals(valueString) || "1".equals(valueString)) {
			return Direction.FORWARD;
		} else if ("-1".equals(valueString)) {
			return Direction.BACKWARD;
		} else if ("no".equals(valueString) || "false".equals(valueString)) {
			return Direction.BOTH;
		} else {
			return null;
		}
		
	}
	
}