package org.openstreetmap.josm.plugins.lanetool.view;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;

import org.openstreetmap.josm.plugins.lanetool.data.LaneGroup;
import org.openstreetmap.josm.plugins.lanetool.data.RelationLane;

/**
 * context menu for clicks on a lane
 */
class LaneGroupPopupMenu extends JPopupMenu {
	
	/** TODO: proper serialVersionUID */
	private static final long serialVersionUID = 1L;

	/**
	 * 
	 * @param lane  lane affected by the user's choice in this menu
	 */
	public LaneGroupPopupMenu(LaneGroup laneGroup) {
		
		//TODO: extract laneValues (also from LanePopupMenu)
		String[] laneValues = {"cycleway", "footway", "vehicle_lane", "bus_lane"};

		JMenu addLaneMenu = new JMenu("add lane");
		this.add(addLaneMenu);

		JMenuItem editLaneItem = new JMenuItem("<<manual>>");
		editLaneItem.addActionListener(new InsertLaneListener(laneGroup, null));
		addLaneMenu.add(editLaneItem);

		for (String presetLabel : laneValues) {			
			JMenuItem lanePresetItem = new JMenuItem(presetLabel);
			lanePresetItem.addActionListener(new InsertLaneListener(laneGroup, presetLabel));
			addLaneMenu.add(lanePresetItem);			
		}

	}
	
	private static class InsertLaneListener implements ActionListener {

		private LaneGroup laneGroup;
		private String laneType;
		
		/**
		 * 
		 * @param lane  
		 * @param laneType  type for the sublane; may be null to indicate manual relation editing
		 */
		public InsertLaneListener(LaneGroup laneGroup, String laneType) {
			this.laneGroup = laneGroup;
			this.laneType = laneType;
		}

		public void actionPerformed(ActionEvent arg0) {
			
			RelationLane newLane = laneGroup.createAndInsertLane(laneType, 0, true);
			if (laneType == null) {
				newLane.editRelation();
			}
			
		}
		
	}
	
}
