package org.openstreetmap.josm.plugins.lanetool.view.style;

import java.awt.Color;
import java.awt.Image;

import org.openstreetmap.josm.plugins.lanetool.data.Lane;

/**
 * abstraction of a set of painting rules for lanes
 */
public interface LanesStyle {

	/**
	 * returns the background color for the lanes view
	 */
	public Color getBackgroundColor();

	/**
	 * returns an image that is to be displayed in the upper left corner of the background, may be null
	 */
	public Image getBackgroundImage();
	
	/**
	 * returns an image that can be used to graphically display a lane.
	 * The image will be painted repeatedly to vertically fill the available space.
	 * 
	 * @param lane  lane to get the image for; null provides no-lane-image
	 */
	public Image getLaneImage(Lane lane);

	/**
	 * returns an image that can be used to graphically display a lane's direction.
	 */
	public Image getDirectionImage(Lane lane);
}
